public class Project
{
	public static void main(String[] args)
	{
		long iniT = System.currentTimeMillis() ;
		
		Functions f = new Functions() ;
		
		// FIND THE CLUSTER SIZES DISTRIBUTION
		//f.clusterSizeDistribution(0.1, 501, 10000) ;
		
		// GENERATE TIME SERIES
		// timeSeriesCBoneProb(double p, double a, int latticeSize, int numSteps, int numExp, double initialPrice, double lambda)
		//f.timeSeriesCBoneProb(0.4, 0.2, 101, 30000, 1, 1, 100) ;
		
		// RUN THE LATTICE FOR EACH PROBABILITY, GET THE CLUSTER SIZES FOR EACH PROBA
		// LINK THEM INTO A BIG ARRAY AND RUN THE CONT-BOUCHAUD MODEL ON THIS ONE
		//f.returnsCBsumProb(0.0005, 101, 100000, 100) ;
		
		// RUN A SIMULATION FOR A GIVEN PROBA AND PUT IT INTO DISTINCT TXT FILES
		//f.returnsCBoneProb(0.3, 0.0005, 501, 100000, 100) ;
		
		// FIND THE CRITICAL PROBABILITY
		//f.findCriticProb(1000, 10) ;
		
		// PLOT AVERAGE CLUSTER NUMBER FOR EACH PROBABILITY
		//f.averageClusterNum(2048,50) ;
		
		// PLOT RANDOM LATTICES
		//Lattice lat = new Lattice(10,0.2) ;
		//Lattice lat = new Lattice(10,0.7) ;
		
		
		// PLOT DETERMINISTIC CLUSTERS
		Lattice lat = new Lattice(7) ;
		/*
		lat.getCell(0,3).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(2,3).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(4,3).setStatus(true) ;
		lat.getCell(5,3).setStatus(true) ;
		lat.getCell(6,3).setStatus(true) ;
		*/
		/*
		lat.getCell(3,0).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(3,2).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(3,4).setStatus(true) ;
		lat.getCell(3,5).setStatus(true) ;
		lat.getCell(3,6).setStatus(true) ;
		*/
		/*
		lat.getCell(0,0).setStatus(true) ;
		lat.getCell(1,1).setStatus(true) ;
		lat.getCell(2,2).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(4,4).setStatus(true) ;
		lat.getCell(5,5).setStatus(true) ;
		lat.getCell(6,6).setStatus(true) ;
		*/
		/*
		lat.getCell(0,0).setStatus(true) ;
		lat.getCell(0,2).setStatus(true) ;
		lat.getCell(0,4).setStatus(true) ;
		lat.getCell(0,6).setStatus(true) ;
		lat.getCell(1,1).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(1,5).setStatus(true) ;
		lat.getCell(2,0).setStatus(true) ;
		lat.getCell(2,2).setStatus(true) ;
		lat.getCell(2,4).setStatus(true) ;
		lat.getCell(2,6).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(3,5).setStatus(true) ;
		lat.getCell(4,0).setStatus(true) ;
		lat.getCell(4,2).setStatus(true) ;
		lat.getCell(4,4).setStatus(true) ;
		lat.getCell(4,6).setStatus(true) ;
		lat.getCell(5,1).setStatus(true) ;
		lat.getCell(5,3).setStatus(true) ;
		lat.getCell(5,5).setStatus(true) ;
		lat.getCell(6,0).setStatus(true) ;
		lat.getCell(6,2).setStatus(true) ;
		lat.getCell(6,4).setStatus(true) ;
		lat.getCell(6,6).setStatus(true) ;
		*/
		/*
		lat.getCell(0,1).setStatus(true) ;
		lat.getCell(1,1).setStatus(true) ;
		lat.getCell(2,1).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(4,1).setStatus(true) ;
		lat.getCell(5,1).setStatus(true) ;
		lat.getCell(5,2).setStatus(true) ;
		lat.getCell(5,3).setStatus(true) ;
		lat.getCell(4,3).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(2,3).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(1,4).setStatus(true) ;
		lat.getCell(1,5).setStatus(true) ;
		lat.getCell(2,5).setStatus(true) ;
		lat.getCell(3,5).setStatus(true) ;
		lat.getCell(4,5).setStatus(true) ;
		lat.getCell(5,5).setStatus(true) ;
		lat.getCell(6,5).setStatus(true) ;
		*/
		/*
		lat.getCell(1,0).setStatus(true) ;
		lat.getCell(1,1).setStatus(true) ;
		lat.getCell(1,2).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(1,4).setStatus(true) ;
		lat.getCell(1,5).setStatus(true) ;
		lat.getCell(2,5).setStatus(true) ;
		lat.getCell(3,5).setStatus(true) ;
		lat.getCell(3,4).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(3,2).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(4,1).setStatus(true) ;
		lat.getCell(5,1).setStatus(true) ;
		lat.getCell(5,2).setStatus(true) ;
		lat.getCell(5,3).setStatus(true) ;
		lat.getCell(5,4).setStatus(true) ;
		lat.getCell(5,5).setStatus(true) ;
		lat.getCell(5,6).setStatus(true) ;
		*/
		/*
		lat.getCell(0,3).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(2,3).setStatus(true) ;
		lat.getCell(2,2).setStatus(true) ;
		lat.getCell(2,1).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(4,1).setStatus(true) ;
		lat.getCell(4,2).setStatus(true) ;
		lat.getCell(4,3).setStatus(true) ;
		lat.getCell(4,4).setStatus(true) ;
		lat.getCell(4,5).setStatus(true) ;
		lat.getCell(4,6).setStatus(true) ;
		*/
		/*
		lat.getCell(0,0).setStatus(true) ;
		lat.getCell(0,1).setStatus(true) ;
		lat.getCell(0,2).setStatus(true) ;
		lat.getCell(0,3).setStatus(true) ;
		lat.getCell(0,4).setStatus(true) ;
		lat.getCell(0,5).setStatus(true) ;
		lat.getCell(0,6).setStatus(true) ;
		lat.getCell(1,0).setStatus(true) ;
		lat.getCell(1,1).setStatus(true) ;
		lat.getCell(1,2).setStatus(true) ;
		lat.getCell(1,3).setStatus(true) ;
		lat.getCell(1,4).setStatus(true) ;
		lat.getCell(1,5).setStatus(true) ;
		lat.getCell(1,6).setStatus(true) ;
		lat.getCell(2,0).setStatus(true) ;
		lat.getCell(2,1).setStatus(true) ;
		lat.getCell(2,2).setStatus(true) ;
		lat.getCell(2,3).setStatus(true) ;
		lat.getCell(2,4).setStatus(true) ;
		lat.getCell(2,5).setStatus(true) ;
		lat.getCell(2,6).setStatus(true) ;
		lat.getCell(3,0).setStatus(true) ;
		lat.getCell(3,1).setStatus(true) ;
		lat.getCell(3,2).setStatus(true) ;
		lat.getCell(3,3).setStatus(true) ;
		lat.getCell(3,4).setStatus(true) ;
		lat.getCell(3,5).setStatus(true) ;
		lat.getCell(3,6).setStatus(true) ;
		lat.getCell(4,0).setStatus(true) ;
		lat.getCell(4,1).setStatus(true) ;
		lat.getCell(4,2).setStatus(true) ;
		lat.getCell(4,3).setStatus(true) ;
		lat.getCell(4,4).setStatus(true) ;
		lat.getCell(4,5).setStatus(true) ;
		lat.getCell(4,6).setStatus(true) ;
		lat.getCell(5,0).setStatus(true) ;
		lat.getCell(5,1).setStatus(true) ;
		lat.getCell(5,2).setStatus(true) ;
		lat.getCell(5,3).setStatus(true) ;
		lat.getCell(5,4).setStatus(true) ;
		lat.getCell(5,5).setStatus(true) ;
		lat.getCell(5,6).setStatus(true) ;
		lat.getCell(6,0).setStatus(true) ;
		lat.getCell(6,1).setStatus(true) ;
		lat.getCell(6,2).setStatus(true) ;
		lat.getCell(6,3).setStatus(true) ;
		lat.getCell(6,4).setStatus(true) ;
		lat.getCell(6,5).setStatus(true) ;
		lat.getCell(6,6).setStatus(true) ;
		*/
		
		
		lat.plotLattice() ;
		Clusters clusters = new Clusters(lat) ;
		clusters.printClusterNumber() ;
		clusters.printClusterSizes() ;
		System.out.println("Percolation?: " + clusters.checkPercolation()) ;
		
		
		long runT = System.currentTimeMillis() - iniT ;
		System.out.println("The running time was: " + runT + " ms.") ;
	}
	
}
